Subject: bug#16231: [PATCH] Fix loop labels

From: "Brian C. Lane" <[email-masked]>
Date: Thu, 17 Apr 2014 15:14:01 -0700

On Sat, Mar 29, 2014 at 01:51:46PM -0400, Phillip Susi wrote:
> Loop labels were incorrectly identifying the device for the fictional
> partition as $dev1 instead of just $dev. This caused other programs like
> gparted to be confused, and caused parted to fail to identify the partition
> as busy due to the fact that it was looking for the wrong device. Parted
> also actually created the partition device so your raw fs on $dev gained an
> alias as $dev1.  Next, writing the label back to the disk clobbered the
> filesystem there if it used the first sector.  Several filesystems end up
> using the first sector for 2048/4096 byte sectors even though they don't
> for 512/1024 byte sectors.  Finally, fat and ntfs boot sectors were being
> detected as msdos labels.
> ---
>  NEWS                       |  2 +
>  include/parted/device.in.h |  1 +
>  libparted/arch/linux.c     | 44 +++++++++++++--------
>  libparted/disk.c           |  2 +
>  libparted/fs/ntfs/ntfs.c   |  2 +-
>  libparted/labels/dos.c     | 29 ++++++++++++++
>  libparted/labels/loop.c    | 42 +++++++-------------
>  partprobe/partprobe.c      |  4 +-
>  tests/Makefile.am          |  1 +
>  tests/t1102-loop-label.sh  | 96 ++++++++++++++++++++++++++++++++++++++++++++++
>  10 files changed, 174 insertions(+), 49 deletions(-)
>  create mode 100644 tests/t1102-loop-label.sh

This makes a whole pile of tests fail. I think I also previously
commented that I wasn't seeing the problem as described -- I need to dig
up that email and read it again.

-- 
Brian C. Lane | Anaconda Team | IRC: bcl #anaconda | Port Orchard, WA (PST8PDT)